/*
 QFeynCADConfigEdit.ui.h
 Copyright (C) 1999-2004 Paolo Ribeca

 This file is part of FeynCAD package.

 FeynCAD is free software;
 you can redistribute it and/or modify it under the terms
 of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with FeynCAD; see the file COPYING.
 If not, write to the Free Software Foundation,
 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#define SETUP_VALIDATOR(validator,LineEdit) \
  QValidator* validator=new QRegExpValidator(regExp,this->LineEdit);\
  this->LineEdit->setValidator(validator);
void QFeynCADConfigEdit::init() {
  this->_fileDialog=
	  new QFileDialog(QDir::currentDirPath(),QString::null,0,0,true);
  QRegExp regExp("\\d{1,4}(\\.\\d{0,4})?|\\.\\d{1,4}");
  SETUP_VALIDATOR(validator9,LineEdit9)
  SETUP_VALIDATOR(validator10,LineEdit10)
  SETUP_VALIDATOR(validator11,LineEdit11)
  SETUP_VALIDATOR(validator12,LineEdit12)
  SETUP_VALIDATOR(validator13,LineEdit13)
  SETUP_VALIDATOR(validator14,LineEdit14)
  SETUP_VALIDATOR(validator15,LineEdit15)
  SETUP_VALIDATOR(validator16,LineEdit16)
  return;
}
#undef SETUP_VALIDATOR

void QFeynCADConfigEdit::setCurrentChanged(QWidget*) {
  this->ListBox->setCurrentItem(this->TabWidget->currentPageIndex());
  return;
}

#define UPDATE_METAPOST(LineEdit,ComboBox) \
  settings >> unit;\
  if (unit==-1)\
  { this->LineEdit->setText(""); this->ComboBox->setCurrentItem(0); }\
  else {\
      settings >> value;\
      this->LineEdit->setText(QString::number(value));\
      this->ComboBox->setCurrentItem(unit);\
  }
void QFeynCADConfigEdit::update() {
  this->SpinBox1->setValue(QFeynCADEditor::_gridX);
  this->SpinBox2->setValue(QFeynCADEditor::_gridY);
  this->SpinBox3->setValue(QFeynCADEditor::_gridStep);
  this->SpinBox4->setValue(QFeynCADEditor::_squareBaseSize);
  this->SpinBox5->setValue(QFeynCADEditor::_circleBaseSize);
  this->SpinBox6->setValue(QFeynCADEditor::_markerStep);
  this->SpinBox7->setValue(QFeynCADEditor::_historyDepth);
  this->LineEdit1->setText(QFeynCADEditor::_tmpPath.c_str());
  this->LineEdit2->setText(QFeynCADEditor::_macrosPath.c_str());
  this->LineEdit3->setText(QFeynCADEditor::_addendumPath.c_str());
  this->LineEdit4->setText(QFeynCADEditor::_metapostPath.c_str());
  this->LineEdit5->setText(QFeynCADEditor::_latexPath.c_str());
  this->LineEdit6->setText(QFeynCADEditor::_dvipsPath.c_str());
  this->LineEdit7->setText(QFeynCADEditor::_gsPath.c_str());
  this->LineEdit8->setText(QFeynCADEditor::_browserPath.c_str());
  this->SpinBox8->setValue(QFeynCADEditor::_timeout);
  this->CheckBox1->setChecked(QFeynCADEditor::_keepFiles);
  istringstream settings(QFeynCADEditor::_metapostSettings);
  int unit;
  float value;
  UPDATE_METAPOST(LineEdit9,ComboBox9)
  UPDATE_METAPOST(LineEdit10,ComboBox10)
  UPDATE_METAPOST(LineEdit11,ComboBox11)
  UPDATE_METAPOST(LineEdit12,ComboBox12)
  UPDATE_METAPOST(LineEdit13,ComboBox13)
  UPDATE_METAPOST(LineEdit14,ComboBox14)
  UPDATE_METAPOST(LineEdit15,ComboBox15)
  UPDATE_METAPOST(LineEdit16,ComboBox16)
  this->SpinBox9->setValue((settings>>unit,unit));
  this->SpinBox10->setValue((settings>>unit,unit));
  this->SpinBox11->setValue((settings>>unit,unit));
  //
  this->normalize();
  return;
}
#undef UPDATE_METAPOST

#define DUMP_METAPOST(LineEdit,ComboBox) \
  if (this->LineEdit->text()==QString(""))\
      newSettings << "-1 ";\
  else\
      newSettings << this->ComboBox->currentItem() << " "\
	           << this->LineEdit->text() << " ";
void QFeynCADConfigEdit::dump() {
  this->PushButtonApply->setEnabled(false);
  this->normalize();
  bool gridChanged=
	  (this->SpinBox3->value()!=QFeynCADEditor::_gridStep||
	   this->SpinBox4->value()!=QFeynCADEditor::_squareBaseSize||
	   this->SpinBox5->value()!=QFeynCADEditor::_circleBaseSize||
	   this->SpinBox6->value()!=QFeynCADEditor::_markerStep);
  bool execsChanged=
	  (this->LineEdit2->text().ascii()!=QFeynCADEditor::_macrosPath||
	   this->LineEdit4->text().ascii()!=QFeynCADEditor::_metapostPath||
	   this->LineEdit5->text().ascii()!=QFeynCADEditor::_latexPath||
	   this->LineEdit6->text().ascii()!=QFeynCADEditor::_dvipsPath||
	   this->LineEdit7->text().ascii()!=QFeynCADEditor::_gsPath);
  QFeynCADEditor::_gridX=this->SpinBox1->value();
  QFeynCADEditor::_gridY=this->SpinBox2->value();
  QFeynCADEditor::_gridStep=this->SpinBox3->value();
  QFeynCADEditor::_squareBaseSize=this->SpinBox4->value();
  QFeynCADEditor::_circleBaseSize=this->SpinBox5->value();
  QFeynCADEditor::_markerStep=this->SpinBox6->value();
  QFeynCADEditor::_historyDepth=this->SpinBox7->value();
  QFeynCADEditor::_tmpPath=this->LineEdit1->text().ascii();
  QFeynCADEditor::_macrosPath=this->LineEdit2->text().ascii();
  QFeynCADEditor::_addendumPath=this->LineEdit3->text().ascii();
  QFeynCADEditor::_metapostPath=this->LineEdit4->text().ascii();
  QFeynCADEditor::_latexPath=this->LineEdit5->text().ascii();
  QFeynCADEditor::_dvipsPath=this->LineEdit6->text().ascii();
  QFeynCADEditor::_gsPath=this->LineEdit7->text().ascii();
  QFeynCADEditor::_browserPath=this->LineEdit8->text().ascii();
  QPsWidget::setGhostscriptPathTo(QFeynCADEditor::_gsPath);
  QFeynCADEditor::_timeout=this->SpinBox8->value();
  QPsWidget::setTimeoutTo(QFeynCADEditor::_timeout);
  QFeynCADEditor::_keepFiles=this->CheckBox1->isChecked();
  ostringstream newSettings;
  DUMP_METAPOST(LineEdit9,ComboBox9)
  DUMP_METAPOST(LineEdit10,ComboBox10)
  DUMP_METAPOST(LineEdit11,ComboBox11)
  DUMP_METAPOST(LineEdit12,ComboBox12)
  DUMP_METAPOST(LineEdit13,ComboBox13)
  DUMP_METAPOST(LineEdit14,ComboBox14)
  DUMP_METAPOST(LineEdit15,ComboBox15)
  DUMP_METAPOST(LineEdit16,ComboBox16)
  newSettings << this->SpinBox9->value() << " ";
  newSettings << this->SpinBox10->value() << " ";
  newSettings << this->SpinBox11->value();
  bool  settingsChanged(newSettings.str()!=QFeynCADEditor::_metapostSettings);
  if (settingsChanged) {
      QFeynCADEditor::_metapostSettings=newSettings.str();
      QMessageBox::warning(this,"QFeynCADConfigurationEditor",
			   "Your global MetaPost settings appear "
			   "to have changed.\n"
			   "Please notice that from now on all your pictures "
			   "(even the old ones)\n"
			   "will be rendered/exported in a different way.");
  }
  if (gridChanged||execsChanged||settingsChanged)
      emit gridSettingsChanged();
  emit displayMessageReq(false,"Modifications to global settings applied.");
  return;
}
#undef DUMP_METAPOST

void QFeynCADConfigEdit::reset() {
  switch (QMessageBox::information(this,"QFeynCADConfigurationEditor",
				   "Please confirm:\n"
				   "Should I reset all the configuration options "
				   "to their default values,\n"
				   "losing all your personal modifications?",
				   "Yes","No, go back",QString::null,0,1)) {
  case 0:
      QFeynCADEditor::resetToDefaults();
      QPsWidget::setGhostscriptPathTo(QFeynCADEditor::_gsPath);
      QPsWidget::setTimeoutTo(QFeynCADEditor::_timeout);
      this->update();
      emit gridSettingsChanged();
      emit displayMessageReq(false,"Global settings reset.");
      break;
  default: break;
  }
  return;
}

void QFeynCADConfigEdit::selectDirTmp() {
  this->_fileDialog->setMode(QFileDialog::DirectoryOnly);
  //this->_fileDialog->setFilter("Directories (*)");
  this->_fileDialog->setViewMode(QFileDialog::Detail);
  if (this->_fileDialog->exec()==QDialog::Accepted) {
      this->LineEdit1->setText(this->_fileDialog->selectedFile());
      this->activateApply();
  }
  return;
}

void QFeynCADConfigEdit::selectFileMacros() {
  this->_fileDialog->setMode(QFileDialog::ExistingFile);
  this->_fileDialog->setFilter("FeynCAD MetaPOST file (FeynCAD.mp)");
  this->_fileDialog->setViewMode(QFileDialog::Detail);
  if (this->_fileDialog->exec()==QDialog::Accepted) {
      this->LineEdit2->setText(this->_fileDialog->selectedFile());
      this->activateApply();
  }
  return;
}

void QFeynCADConfigEdit::selectFileAddendum() {
  this->_fileDialog->setMode(QFileDialog::ExistingFile);
  this->_fileDialog->setFilter("User MetaPOST file (*.mp)");
  this->_fileDialog->setViewMode(QFileDialog::Detail);
  if (this->_fileDialog->exec()==QDialog::Accepted) {
      this->LineEdit3->setText(this->_fileDialog->selectedFile());
      this->activateApply();
  }
  return;
}

void QFeynCADConfigEdit::selectFileMetapost() {
  this->_fileDialog->setMode(QFileDialog::ExistingFile);
  this->_fileDialog->setFilter("Executable files (*)");
  this->_fileDialog->setViewMode(QFileDialog::Detail);
  if (this->_fileDialog->exec()==QDialog::Accepted) {
      this->LineEdit4->setText(this->_fileDialog->selectedFile());
      this->activateApply();
  }
  return;
}

void QFeynCADConfigEdit::selectFileLatex() {
  this->_fileDialog->setMode(QFileDialog::ExistingFile);
  this->_fileDialog->setFilter("Executable files (*)");
  this->_fileDialog->setViewMode(QFileDialog::Detail);
  if (this->_fileDialog->exec()==QDialog::Accepted) {
      this->LineEdit5->setText(this->_fileDialog->selectedFile());
      this->activateApply();
  }
  return;
}

void QFeynCADConfigEdit::selectFileDvips() {
  this->_fileDialog->setMode(QFileDialog::ExistingFile);
  this->_fileDialog->setFilter("Executable files (*)");
  this->_fileDialog->setViewMode(QFileDialog::Detail);
  if (this->_fileDialog->exec()==QDialog::Accepted) {
      this->LineEdit6->setText(this->_fileDialog->selectedFile());
      this->activateApply();
  }
  return;
}

void QFeynCADConfigEdit::selectFileGhostscript() {
  this->_fileDialog->setMode(QFileDialog::ExistingFile);
  this->_fileDialog->setFilter("Executable files (*)");
  this->_fileDialog->setViewMode(QFileDialog::Detail);
  if (this->_fileDialog->exec()==QDialog::Accepted) {
      this->LineEdit7->setText(this->_fileDialog->selectedFile());
      this->activateApply();
  }
  return;
}

void QFeynCADConfigEdit::selectFileBrowser() {
  this->_fileDialog->setMode(QFileDialog::ExistingFile);
  this->_fileDialog->setFilter("Executable files (*)");
  this->_fileDialog->setViewMode(QFileDialog::Detail);
  if (this->_fileDialog->exec()==QDialog::Accepted) {
      this->LineEdit8->setText(this->_fileDialog->selectedFile());
      this->activateApply();
  }
  return;
}

void QFeynCADConfigEdit::activateApply() {
  if (!this->PushButtonApply->isEnabled())
      this->PushButtonApply->setEnabled(true);
  return;
}

pair<QString,string> validate(const string& name,int type,const QString& value) {
  double dValue=value.toDouble();
  switch (type) {
  case 0: if (dValue>1400.) dValue=1400.; else return make_pair(value,""); break; // mm
  case 1: if (dValue>50.) dValue=50.; else return make_pair(value,""); break; // in
  case 2: if (dValue>4000.) dValue=4000.; else return make_pair(value,""); break; // pt
  case 3: if (dValue>3700.) dValue=3700.; else return make_pair(value,""); break; // dd
  case 4: if (dValue>4000.) dValue=4000.; else return make_pair(value,""); break; // bp
  default:
      abort(); // Agonizing pain
      break;
  }
  // Se siamo arrivati qui vuol dire che c'e' qualcosa che non va
  ostringstream message;
  message << "Value of \"" << name << "\" was out of range." << endl
	  << "  ==>Quantity \"" << name << "\" has been lowered to " << dValue
	  << ".<==" << endl;
  return make_pair(QString::number(dValue),message.str());
}

#define VALIDATE(lineEdit,comboBox,name) \
  this->lineEdit->setText((res=validate(name,\
	this->comboBox->currentItem(),this->lineEdit->text())).first);\
  message+=res.second;
//
void QFeynCADConfigEdit::normalize() {
  pair<QString,string> res;
  string message;
  VALIDATE(LineEdit9,ComboBox9,"thin")
  VALIDATE(LineEdit10,ComboBox10,"arrow_len")
  VALIDATE(LineEdit11,ComboBox11,"curly_len")
  VALIDATE(LineEdit12,ComboBox12,"dash_len")
  VALIDATE(LineEdit13,ComboBox13,"dot_len")
  VALIDATE(LineEdit14,ComboBox14,"wiggly_len")
  VALIDATE(LineEdit15,ComboBox15,"zigzag_len")
  VALIDATE(LineEdit16,ComboBox16,"zigzag_width")
  if (message.size())
      QMessageBox::information(this,"QFeynCADConfigurationEditor",message.c_str(),
			       "Accept");
  return;
}
