/*
 QFeynCADHelp.ui.h
 Copyright (C) 1999-2004 Paolo Ribeca

 This file is part of FeynCAD package.

 FeynCAD is free software;
 you can redistribute it and/or modify it under the terms
 of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with FeynCAD; see the file COPYING.
 If not, write to the Free Software Foundation,
 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

void QFeynCADHelp::init() {
  QString overview=
#include "strings/docs/overview.string"
	  ;
  this->TextBrowser1->setText(overview);
  QString installation=
#include "strings/docs/installation.string"
	  ;
  this->TextBrowser2->setText(installation);
  QString commandline=
#include "strings/docs/commandline.string"
	  ;
  this->TextBrowser3->setText(commandline);
  QString elements=
#include "strings/docs/elements.string"
	  ;
  this->TextBrowser4->setText(elements);
  QString drawing=
#include "strings/docs/drawing.string"
	  ;
  this->TextBrowser5->setText(drawing);
  QString editing=
#include "strings/docs/editing.string"
	  ;
  this->TextBrowser6->setText(editing);
  QString objects=
#include "strings/docs/objects.string"
	  ;
  this->TextBrowser7->setText(objects);
  QString vertices=
#include "strings/docs/vertices.string"
	  ;
  this->TextBrowser8->setText(vertices);
  QString lines=
#include "strings/docs/lines.string"
	  ;
  this->TextBrowser9->setText(lines);
  QString tags=
#include "strings/docs/tags.string"
	  ;
  this->TextBrowser10->setText(tags);
  QString selections=
#include "strings/docs/selections.string"
	  ;
  this->TextBrowser11->setText(selections);
  QString more=
#include "strings/docs/more.string"
	  ;
  this->TextBrowser12->setText(more);
  QString accelerators=
#include "strings/docs/accelerators.string"
	  ;
  this->TextBrowser13->setText(accelerators);
  QString configuration=
#include "strings/docs/configuration.string"
	  ;
  this->TextBrowser14->setText(configuration);
  QString customizing=
#include "strings/docs/customizing.string"
	  ;
  this->TextBrowser15->setText(customizing);
  QString faq=
#include "strings/docs/faq.string"
	  ;
  this->TextBrowser16->setText(faq);
  return;
}

void QFeynCADHelp::parseLink(const QString & link) {
  if (link.contains('#')==2) {
      // An external link: we span the external browser
      QString first=link;
      QRegExp regExp("#(.+)#(.+)");	
      first.replace(regExp,"\\1://\\2");
      first.replace("mailto://","mailto:");
      if (QFeynCADEditor::_browserPath=="") {
	  ostringstream message;
	  message << "You must specify an existing external browser in your configuration\n"
		  << "(menu \"Edit->Global settings->Paths & commands->External browser\")"
		  << "\nif you want to be able to visit links to non-local documents.";
	  QMessageBox::warning(this,"QFeynCADHelp",message.str().c_str());
	  return;
      }
      ostringstream command;
      command << QFeynCADEditor::_browserPath << " " << first
	      << " >& /dev/null 2>&1 &";
      if (system(command.str().c_str())) {
	  ostringstream message;
	  message << "Could not span specified external browser \""
		  << QFeynCADEditor::_browserPath << "\"\n(\"" << command.str() << "\").";
	  QMessageBox::warning(this,"QFeynCADHelp",message.str().c_str());
      }
  } else {
      // An internal link: we parse it
      QString first=link,second=link;
      QRegExp regExp("#([^\\/]+)(/(.+))*");	
      first.replace(regExp,"\\1");
      second.replace(regExp,"\\3");
      //cout << first << " " << second << endl;
      if (first=="Overview") {
	  this->ToolBox->setCurrentIndex(1);
	  if (second!="")
	      this->TextBrowser1->scrollToAnchor(second);
      } else if (first=="Installation") {
	  this->ToolBox->setCurrentIndex(2);
	  if (second!="")
	      this->TextBrowser2->scrollToAnchor(second);
      } else if (first=="Commandline") {
	  this->ToolBox->setCurrentIndex(3);
	  if (second!="")
	      this->TextBrowser3->scrollToAnchor(second);
      } else if (first=="Elements") {
	  this->ToolBox->setCurrentIndex(4);
	  if (second!="")
	      this->TextBrowser4->scrollToAnchor(second);
      } else if (first=="Drawing") {
	  this->ToolBox->setCurrentIndex(5);
	  if (second!="")
	      this->TextBrowser5->scrollToAnchor(second);
      } else if (first=="Editing") {
	  this->ToolBox->setCurrentIndex(6);
	  if (second!="")
	      this->TextBrowser6->scrollToAnchor(second);
      } else if (first=="Objects") {
	  this->ToolBox->setCurrentIndex(7);
	  if (second!="")
	      this->TextBrowser7->scrollToAnchor(second);
      } else if (first=="Vertices") {
	  this->ToolBox->setCurrentIndex(8);
	  if (second!="")
	      this->TextBrowser8->scrollToAnchor(second);
      } else if (first=="Lines") {
	  this->ToolBox->setCurrentIndex(9);
	  if (second!="")
	      this->TextBrowser9->scrollToAnchor(second);
      } else if (first=="Tags") {
	  this->ToolBox->setCurrentIndex(10);
	  if (second!="")
	      this->TextBrowser10->scrollToAnchor(second);
      } else if (first=="Selections") {
	  this->ToolBox->setCurrentIndex(11);
	  if (second!="")
	      this->TextBrowser11->scrollToAnchor(second);
       } else if (first=="More") {
	  this->ToolBox->setCurrentIndex(12);
	  if (second!="")
	      this->TextBrowser12->scrollToAnchor(second);
     } else if (first=="Accelerators") {
	  this->ToolBox->setCurrentIndex(13);
	  if (second!="")
	      this->TextBrowser13->scrollToAnchor(second);
      } else if (first=="Configuration") {
	  this->ToolBox->setCurrentIndex(14);
	  if (second!="")
	      this->TextBrowser14->scrollToAnchor(second);
      } else if (first=="Customizing") {
	  this->ToolBox->setCurrentIndex(15);
	  if (second!="")
	      this->TextBrowser15->scrollToAnchor(second);
      } else if (first=="Faq") {
	  this->ToolBox->setCurrentIndex(16);
	  if (second!="")
	      this->TextBrowser16->scrollToAnchor(second);
      }
  }
  return;
}
