/*
 QFeynCADInfos.ui.h
 Copyright (C) 1999-2004 Paolo Ribeca

 This file is part of FeynCAD package.

 FeynCAD is free software;
 you can redistribute it and/or modify it under the terms
 of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with FeynCAD; see the file COPYING.
 If not, write to the Free Software Foundation,
 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

void QFeynCADInfos::init() {
  QString contact=
#include "strings/infos/contact.string"
	  ;
  this->TextBrowser1->setText(contact);
  QString credits=
#include "strings/infos/credits.string"
	  ;
  this->TextBrowser2->setText(credits);
  QString contributions=
#include "strings/infos/contributions.string"
	  ;
  this->TextBrowser3->setText(contributions);
  QString license=
#include "strings/infos/license.string"
	  ;
  this->TextEdit4->setText(license);
  return;
}

void QFeynCADInfos::parseLink( const QString & link ) {
  // Qui tutti i link sono esterni
  QString first=link;
  QRegExp regExp("#(.+)#(.+)");	
  first.replace(regExp,"\\1://\\2");
  first.replace("mailto://","mailto:");
  if (QFeynCADEditor::_browserPath=="") {
      ostringstream message;
      message << "You must specify an existing external browser in your configuration\n"
	      << "(menu \"Edit->Global settings->Paths & commands->External browser\")"
	      << "\nif you want to be able to visit links to non-local documents.";
      QMessageBox::warning(this,"QFeynCADHelp",message.str().c_str());
      return;
  }
  ostringstream command;
  command << QFeynCADEditor::_browserPath << " " << first
	  << " >& /dev/null 2>&1 &";
  if (system(command.str().c_str())) {
      ostringstream message;
      message << "Could not span specified external browser \""
	      << QFeynCADEditor::_browserPath << "\"\n(\"" << command.str() << "\").";
      QMessageBox::warning(this,"QFeynCADHelp",message.str().c_str());
  }
  return;
}
